<template>
  <div class="page-container d-flex">
    <form @submit="submit" class="d-flex flex-column card-form p-20 radius">
      <h2>Connexion</h2>
      <div class="p-10 d-flex flex-column">
        <label for="email">Adresse E-mail</label>
        <input
          v-model="emailValue"
          id="email"
          class="input radius"
          type="email"
          name="email"
        />
        <p class="error" v-if="emailError">{{ emailError }}</p>
      </div>

      <div class="p-10 d-flex flex-column">
        <label for="password">Mot de passe</label>
        <input
          v-model="passwordValue"
          id="password"
          class="input radius"
          type="password"
          name="password"
        />
        <p class="error" v-if="passwordError">{{ passwordError }}</p>
      </div>

      <button class="button radius" type="submit">Connexion</button>
    </form>
  </div>
</template>

<script setup lang="ts">
import { z } from "zod";
import { toFormValidator } from "@vee-validate/zod";
import { useField, useForm } from "vee-validate";
import type { LoginForm } from "@/shared/interfaces";
import { useRouter } from "vue-router";
import { useUser } from "@/shared/stores";

const router = useRouter();
const userStore = useUser();
const error = userStore.error;

const validationSchema = toFormValidator(
  z.object({
    email: z
      .string({ required_error: "Vous devez renseigner votre email" })
      .email("format de l'email incorect"),
    password: z
      .string({ required_error: "Vous devez renseigner votre Mot de passe" })
      .min(8, "Mot de passe trop court 8 caractères minimum"),
  })
);

const { handleSubmit, setErrors } = useForm<{
  email: string;
  password: string;
}>({
  validationSchema,
});

const submit = handleSubmit(async (formValue: LoginForm) => {
  try {
    await userStore.login(formValue);
    router.push("/dashboard");
  } catch (e) {
    console.log("error submit", e);
  }
});

const { value: emailValue, errorMessage: emailError } = useField("email");
const { value: passwordValue, errorMessage: passwordError } =
  useField("password");
</script>

<style scoped lang="scss">
form {
  height: auto;
  margin: auto;
  width: 450px;
}
@media screen and (max-width: 500px) {
  form {
    width: calc(100% - 30px);
  }
}

.error {
  padding: 10px;
  margin: 0;
  box-sizing: border-box;
  color: #c23616;
}

label {
  padding-bottom: 5px;
}

button {
  margin: 10px;
}
</style>
